﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace DataGridView_Filter_CheckBox
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.PopulateCheckBoxes();
            this.PopulateDataGridView();
        }

        private void Country_Checked(object sender, EventArgs e)
        {
            this.PopulateDataGridView();
        }

        private void PopulateCheckBoxes()
        {
            string query = "SELECT DISTINCT TOP 3 Country FROM Customers";
            string constr = @"Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
                {
                    //Fill the DataTable with records from Table.
                    DataTable dt = new DataTable();
                    sda.Fill(dt);

                    //Loop and add CheckBoxes to FloyLayoutPanel.
                    foreach (DataRow row in dt.Rows)
                    {
                        CheckBox chk = new CheckBox();
                        chk.Text = row["Country"].ToString();
                        chk.CheckedChanged += new EventHandler(Country_Checked);
                        checkBoxPanel.Controls.Add(chk);
                    }
                }
            }
        }

        private void PopulateDataGridView()
        {
            string query = "SELECT CustomerID, ContactName, Country FROM Customers";

            string condition = string.Empty;
            foreach (CheckBox chk in checkBoxPanel.Controls.OfType<CheckBox>())
            {
                condition += chk.Checked ? string.Format("'{0}',", chk.Text) : string.Empty;
            }

            if (!string.IsNullOrEmpty(condition))
            {
                condition = string.Format(" WHERE Country IN ({0})", condition.Substring(0, condition.Length - 1));
            }

            string constr = @"Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlCommand cmd = new SqlCommand(query + condition, con))
                {
                    using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                    {
                        DataTable dt = new DataTable();
                        sda.Fill(dt);
                        dataGridView1.DataSource = dt;
                    }
                }
            }
        }
    }
}
